=== ElmerGUItester/CMakeLists.txt ===
PROJECT(ElmerGUItester CXX)
CMAKE_MINIMUM_REQUIRED(VERSION 2.8)


IF(WITH_QT5)
  MESSAGE(STATUS "------------------------------------------------")
  SET(QT5_PKG_LIST Qt5Gui Qt5Core Qt5Widgets)
  FOREACH(_pkg ${QT5_PKG_LIST})
    FIND_PACKAGE(${_pkg} PATHS ${QT5_PATH})
  ENDFOREACH()
  ADD_DEFINITIONS(-DWITH_QT5)
ELSE()
  FIND_PACKAGE(Qt4 COMPONENTS QtGui QtCore REQUIRED)
ENDIF()

SET(CMAKE_INCLUDE_CURRENT_DIR ON)
SET(CMAKE_AUTOMOC ON)
SET(CMAKE_AUTORCC ON)
SET(CMAKE_AUTOUIC OFF)

SET(TARGETS ElmerGUItester)

SET(HEADERS src/tester.h)
SET(FORMS forms/mainform.ui)
SET(SOURCES src/main.cpp src/tester.cpp)

SET(RESOURCES ElmerGUItester.qrc)
SET(WIN32_RC_FILE ElmerGUItester.rc)

IF(WITH_QT5)
  QT5_WRAP_UI(UI_HEADERS ${FORMS})
  QT5_ADD_RESOURCES(UI_RESOURCES ${RESOURCES})
  ADD_DEFINITIONS(-DWITH_QT5)
ELSE()
  QT4_WRAP_UI(UI_HEADERS ${FORMS})
  QT4_ADD_RESOURCES(UI_RESOURCES ${RESOURCES})
  INCLUDE(${QT_USE_FILE})
  ADD_DEFINITIONS(${QT_DEFINITIONS})
ENDIF()

IF(MINGW AND WIN32)
  SET(CMAKE_RC_COMPILER_INIT windres)
  ENABLE_LANGUAGE(RC)
  SET(CMAKE_RC_COMPILE_OBJECT
    "<CMAKE_RC_COMPILER> <FLAGS> -O coff <DEFINES> -i <SOURCE> -o <OBJECT>")
  SET(SOURCES ${SOURCES} ${WIN32_RC_FILE})
ENDIF()

INCLUDE_DIRECTORIES(${APPLICATION_INCLUDE_DIRS})
ADD_EXECUTABLE(ElmerGUItester WIN32 ${SOURCES} ${UI_HEADERS} ${UI_RESOURCES})

IF(WITH_QT5)
  QT5_USE_MODULES(ElmerGUItester Gui Core Widgets)
ENDIF()

TARGET_LINK_LIBRARIES(ElmerGUItester ${QT_LIBRARIES})
INSTALL(TARGETS ElmerGUItester RUNTIME DESTINATION "bin" COMPONENT "elmergui")
