=== license_texts/CMakeLists.txt ===
#FIND_FILE(GPL2_FILE GPL-2.txt PATHS ${CMAKE_CURRENT_SOURCE_DIR} NO_DEFAULT_PATH)
#FIND_FILE(LGPL2.1_FILE LGPL-2.1.txt PATHS ${CMAKE_CURRENT_SOURCE_DIR} NO_DEFAULT_PATH)
#FIND_FILE(LICENSES_ALL LICENSES PATHS ${CMAKE_CURRENT_SOURCE_DIR} NO_DEFAULT_PATH)

INSTALL(FILES "GPL-2.txt" "LGPL-2.1.txt" "LICENSES"
  DESTINATION "share/elmersolver/license_texts")

#INSTALL(FILES ${GPL2_FILE} ${LGPL2.1_FILE} ${LICENSES_ALL}
  #DESTINATION "share/elmersolver/license_texts")
#MARK_AS_ADVANCED(GPL2_FILE LGPL2.1_FILE LICENSES_ALL)
