=== meshgen2d/CMakeLists.txt ===
CONFIGURE_FILE(config.h.cmake config.h)

ADD_SUBDIRECTORY(src)
