=== post/CMakeLists.txt ===
PROJECT(ElmerPost Fortran C CXX)
cmake_minimum_required(VERSION 2.8)

SET(CMAKE_MODULE_PATH ${CMAKE_ROOT}/Modules "${PROJECT_SOURCE_DIR}/cmake/Modules" )

SET(ELMER_POST_DATADIR "share/elmerpost")

ADD_DEFINITIONS(-DUSE_ISO_C_BINDINGS)
include(CheckIncludeFiles)
CHECK_INCLUDE_FILES(strings.h HAVE_STRINGS_H)
CHECK_INCLUDE_FILES(string.h HAVE_STRING_H)

#SET(TCL_VERSION_STRING 8.5)
#SET(TCLSH_VERSION_STRING 8.5)
FIND_PACKAGE(TCL REQUIRED) # This finds Tk too
FIND_PACKAGE(OpenGL REQUIRED)
SET(USE_INTERP_RESULT TRUE)

MESSAGE(STATUS "OPENGL_LIBRARIES = ${OPENGL_LIBRARIES}")
MESSAGE(STATUS "TCL_LIBRARY = ${TCL_LIBRARY}")
MESSAGE(STATUS "TCL_INCLUDE_PATH = ${TCL_INCLUDE_PATH}")
MESSAGE(STATUS "TK_LIBRARY = ${TK_LIBRARY}")
MESSAGE(STATUS "TK_INCLUDE_PATH = ${TK_INCLUDE_PATH}")

SET(FC_STDCALLBULL " " )
SET(STDCALLBULL TRUE)
#cmakedefine STDCALLBULL @FC_STDCALLBULL@
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR}/src)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/../matc/src)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/src)


IF(NOT(TARGET matc))
  add_subdirectory(matc)
ENDIF(NOT(TARGET matc))
add_subdirectory(src)

SET_PROPERTY(DIRECTORY src PROPERTY INCLUDE_DIRECTORIES "${CMAKE_CURRENT_SOURCE_DIR}/src" "${CMAKE_CURRENT_BINARY_DIR}/src" "${CMAKE_CURRENT_SOURCE_DIR}/../matc/src")

INSTALL(DIRECTORY "doc/" DESTINATION "${ELMER_POST_DATADIR}/help" COMPONENT ElmerPost)
INSTALL(FILES "tcl_license.terms" "tk_license.terms" DESTINATION "${ELMER_POST_DATADIR}/licenses" COMPONENT ElmerPost)

IF(MINGW)
  SET(MINGW32 TRUE CACHE BOOL "")
  MESSAGE(STATUS "MING32 detected")
  MESSAGE(WARNING "Installing (tcl|tk)_include_path/../(bin|lib)/")
  INSTALL(DIRECTORY "${TCL_INCLUDE_PATH}/../bin/" DESTINATION "bin")
  INSTALL(DIRECTORY "${TCL_INCLUDE_PATH}/../lib/" DESTINATION "lib")
  INSTALL(DIRECTORY "${TK_INCLUDE_PATH}/../bin/" DESTINATION "bin")
  INSTALL(DIRECTORY "${TK_INCLUDE_PATH}/../lib/" DESTINATION "lib")
ENDIF(MINGW)


########### install files ###############




#original Makefile.am contents follow:

#SUBDIRS=src
